/***************************************************************************
 *   Copyright (C) 2007, 2008, 2009 by David Bitseff                       *
 *   dbitsef@zipcon.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DIRECTORYVIEWWIDGET_H
#define DIRECTORYVIEWWIDGET_H

#include <QWidget>
#include <QFileSystemModel>

#include "ui_directoryviewwidget.h"
#include "flamfileiconprovider.h"


class DirectoryViewWidget : public QWidget, private Ui::DirectoryViewWidget
{
	Q_OBJECT

	private:
		QFileSystemModel* model;
		FlamFileIconProvider* icon_provider;
		QString path;

	protected:
		void closeEvent(QCloseEvent*);

	protected slots:
		void openDirectoryAction(bool);
		void selectFileAction(const QModelIndex&);
		void dirLineEditChangedAction();

	public:
		DirectoryViewWidget(QWidget* parent=0);
		~DirectoryViewWidget();
		void setCurrentPath(QString);
		QString currentPath();

	signals:
		void flam3FileSelected(const QString&,bool =false);
};

#endif
