/***************************************************************************
 *   Copyright (C) 2007 by David Bitseff                                   *
 *   dbitsef@zipcon.net                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef LUATHREAD_H
#define LUATHREAD_H

#include <QThread>
#include "isaac.h"
#include "renderthread.h"

class MainWindow;
class lua_State;

namespace Lua
{
class Frame;
class LuaThread : public QThread
{
	Q_OBJECT

	MainWindow* mw;
	Frame* f;
	QString lua_text;
	QString lua_error;
	bool lua_stopluathread_script;
	randctx ctx;

	public:
		LuaThread(MainWindow* m,  QObject* parent=0);
		~LuaThread();
		void msleep(unsigned long msecs);
		virtual void run();
		void setLuaText(QString);
		const QString& luaText();
		void stopScript();
		bool stopping() const;
		QString getMessage();
		static int lua_stopluathread(lua_State*);
		static int lua_irand(lua_State*);
		static int lua_msleep(lua_State*);

	signals:
		void scriptFinished();
		void scriptStopped();

	protected:
		void lua_load_environment(lua_State*);

};
}
#include "frame.h"


#endif
